#include <sys/stat.h>
#include <cerrno>
#include <fstream>
#include <iostream>
#include <mysqlcppapi/mysqlcppapi.h>
#include <string.h>

const char  MY_DATABASE[]="telcent";
const char  MY_TABLE[]="fax";
const char  MY_HOST[]="localhost";
const char  MY_USER[]="root";
const char  MY_PASSWORD[]="";
const char  MY_FIELD[]="fax"; // BLOB field

int main(int argc, char *argv[]) {
  if (argc < 2) {
    std::cerr << "Usage: load_file file\n";
    return 1;
  }
  mysqlcppapi::Connection con;
  try {
    con.set_Host(MY_HOST);
    con.set_User(MY_USER);
    con.set_Password(MY_PASSWORD);
    con.set_Port(3306);
    con.connect();
    con.select_database(MY_DATABASE);
      
    std::ifstream in(argv[1],std::ios::in | std::ios::binary);
    if (in.is_open()) {

      mysqlcppapi::Query query = con.create_Query();
      std::ostringstream escbuf;
      escbuf << in.rdbuf();
      query  << "INSERT INTO " << MY_TABLE
          << " (" << MY_FIELD << ") VALUES(\""
          << mysqlcppapi::escape(escbuf.str()) << "\")";
      query.execute();
    }
    else 
    {
      std::cerr << "load_file: " << argv[1] << ": " << strerror(errno) << '\n';
      return 1;
    }
    return 0;
  } catch (mysqlcppapi::ex_BadQuery& er) { 
      std::cerr << "load_file: " << er.what() << '\n';
    return 1;
  }
}
