#include <mysqlcppapi/mysqlcppapi.h>
#include <vector>
#include <string>
#include <iostream>
#include <iomanip>

std::vector<std::string> yy;

int main() {
  mysqlcppapi::Connection con;
  try {
    con.set_Host("localhost");
    con.set_User("root");
    con.set_Port(3306);
    con.set_Timeout(60);
    con.connect();
            
    std::cout << con.get_client_info() << std::endl << std::endl;
    mysqlcppapi::Query query = con.create_Query();

    query << "show databases";

    mysqlcppapi::Result_Store res = query.store();

    std::cout << "Query: " << query.preview() << std::endl;

    std::cout << "Records Found: " << res.size() << std::endl << std::endl;
    
    mysqlcppapi::Row row;
    std::cout.setf(std::ios::left);
    std::cout << std::setw(17) << "Databases"  << std::endl << std::endl;
    
    mysqlcppapi::Result_Store::iterator i;
    for (i = res.begin(); i != res.end(); i++) {
      row = *i;
      std::cout << std::setw(17) << row[0]  << std::endl;
    }
    std::string database = "mysql";
    con.select_database(database);

    query.str("");

    query << "show tables";

    res = query.store();

    std::cout << "Query: " << query.preview() << std::endl;

    std::cout << "Records Found: " << res.size() << std::endl << std::endl;
    
    std::cout.setf(std::ios::left);
    std::cout << std::setw(17) << "Tables"  << std::endl << std::endl;
        
    for (i = res.begin(); i != res.end(); i++) {
      row = *i;
      std::string xx(row[0]);
      std::cout << std::setw(17) << row[0]  << std::endl;
      yy.insert(yy.end(),xx);
    }
    for (unsigned int j = 0; j < yy.size();j++) {
      query.str("");
      query << "describe " << yy[j];
      std::cout << query.preview() << std::endl << std::endl;
      res = query.store();
      unsigned int columns = res.size(), counter;
          std::cout << std::setw(15) << std::endl;
      const mysqlcppapi::Fields& fields = res.get_fields(); 
      for (counter = 0; counter < fields.size(); counter++) {
              std::cout << std::setw(15) << fields[counter].get_Name() << "  ";
      }
          std::cout << std::endl << std::endl;
      for (i = res.begin(); i!=res.end();i++) {
        row = *i;
        for (counter = 0; counter < columns; counter++)  {
                  std::cout << row[counter] << "  ";
        }
              std::cout << std::endl;
      }
    }
    query.str("");
    query << "select * from user";
    res  =  query.store(); int columns =  res.num_fields();
        std::cout << query.preview() << std::endl << std::endl;
        std::cout << "fields = " << res.num_fields() << "rows = " << res.size() << std::endl;
    
    for (i = res.begin(); i!=res.end();i++) {
      row = *i;
      for (int counter = 0; counter < columns; counter++)  {
                std::cout << row[counter] << "  ";
      }
            std::cout << std::endl;
    }
  } catch (mysqlcppapi::ex_BadQuery& er){ // handle any connection 
                         // or query errors that may come up
      std::cerr << "Error: " << er.what() << " " << con.errnum() << std::endl;
    return -1;

  } catch (mysqlcppapi::ex_BadConversion& er) {
    // we still need to catch bad conversions in case something goes 
    // wrong when the data is converted into stock
      std::cerr << "Error: Tried to convert \"" << er.get_Data() << "\" to a \""
   << er.get_TypeName() << "\"." << std::endl;
    return -1;
  }

}

